import java.awt.*;
import java.awt.event.*;
import javax.swing.JWindow;
import javax.swing.JPanel;
import com.sun.awt.AWTUtilities;

ScrollFrame sf;

PImage[] container = new PImage[3];

PGraphics Explanation;

PImage nmos_h;
PImage pmos_h;
PImage cmos_h;

PImage picto;
PImage ground;
PImage ground2;

PImage backgnd;
PImage info_mouse, info_mouse0_h;
PImage info_mouse1, info_mouse1_h;
color t;
color n;

PImage transistor_mask;
PImage[] tm = new PImage[9];
int ncontrol_mask = 1;
int pcontrol_mask = 1;

int type = 0; // 0: NMOS, 1: PMOS, 2: CMOS

void setup() {
  size(800, 600); 
  
  backgnd = loadImage("back.jpg");
  
  Explanation = createGraphics (228, 183, P2D);
  
  v_display1d = loadImage("variac1d.png");
  v_display1g = loadImage("variac1g.png");
  v_display2d = loadImage("variac2d.png");
  v_display2g = loadImage("variac2g.png");
  transistor_mask = loadImage("transistor_mask.png");
  
  tm[0] = transistor_mask;
  for (int i = 1; i < tm.length; i++)
    tm[i] = loadImage("t" + (i - 1) + ".png");
  
  picto = loadImage("picto.png");
  ground = loadImage("ground.png");
  ground2 = loadImage("ground2.png");
  
  // Containers do mouse
  
  info_mouse = loadImage("info_mouse0.png");
  info_mouse0_h = loadImage("info_mouse0_h.png");
  info_mouse1 = loadImage("info_mouse1.png");
  info_mouse1_h = loadImage("info_mouse1_h.png");
  
  // Containers
  
  container[0] = loadImage("nmos_back.png");
  container[1] = loadImage("pmos_back.png");
  container[2] = loadImage("cmos_back.png");
  
  nmos_h = loadImage("nmos_h.png");
  pmos_h = loadImage("pmos_h.png");
  cmos_h = loadImage("cmos_h.png");
  
  // Mídia da area do NMOS
  
  t_nmos = loadImage("N_channel.png");
  eletrons = new ArrayList();
  holes = new ArrayList();
  
  for (int i = 0; i < n_text.length; i++)
    n_text[i] = loadImage("n_t" + i + ".png");
  
  nb_on = loadImage("b1_on.png");
  nb_off = loadImage("b1_off.png");
  
  // Midia da area do PMOS

  t_pmos = loadImage("P_channel.png");  
  eletrons2 = new ArrayList();
  holes2 = new ArrayList();
  
  for (int i = 0; i < p_text.length; i++)
    p_text[i] = loadImage("p_t" + i + ".png");
  
  // Midia da area do CMOS

  t_cmos = loadImage("P_channel.png");  
  
  // Explicação
  
  back_exp = loadImage("teste.png");
  for (int i = 0; i < n_exp.length; i++)
    n_exp[i] = loadImage("n_exp" + i + ".png");
  for (int i = 0; i < p_exp.length; i++)
    p_exp[i] = loadImage("p_exp" + i + ".png");
  
  verdana10 = loadFont("Verdana-10.vlw");
  
  GLOBAL = new globalTrickery(this);
  sf = new ScrollFrame(this, this.g, 515 + 114, 55 + 120, 225, 240, 225, 650, 20, 20,
                  color(255, 255, 255, 120), color(200, 200, 200, 70),
                  color(255, 255, 255, 75), color(0, 200, 200, 150));
                  
  sf.setBorderSF(2, color(200, 200, 200, 255), 0.5, 0.5, 30, 255, 30);
  sf.setVAMargins(5, 7, 10, 5);
  sf.setBorderVA(4, color(220, 220, 220, 150), 0.5, 0.5, 0, 255, 3);
  sf.setBG(new ImageBox(this, this.g, sf.x, sf.y, sf.w, sf.h, color(180, 180, 180, 100), 0, 0));
  sf.setUpdateVATransparent(true); sf.setVABGFillsWholeVA(false); sf.setVABG();
  GLOBAL.setupDone();
  
}

void draw() {

  t_mask();
  background(backgnd);

  smooth();  
  
  switch(type) {
    case 0: drawNMOS(); variac_display(angle1, angle2, 1); break;
    case 1: drawPMOS(); variac_display(angle3, angle4, -1); break;
    case 2: drawCMOS(); break;
  }
  
  if (type != 2)
    image(picto, 225, 480);
  
  // Parte da explicação
  
  //image(Explanation, 515, 55);
  //explanation();
  
  sf.display();
  sf.beginVADraw();
  
  sf.getVA().fill(0);
  
  sf.getVA().textFont(verdana10);
  
  if (type == 0)
    sf.getVA().image(n_exp[nexp_counter], n_exp[nexp_counter].width/2 - 10, n_exp[nexp_counter].height/2 - 10);
    
  if (type == 1) {
    sf.getVA().image(p_exp[pexp_counter], p_exp[pexp_counter].width/2 - 10, p_exp[pexp_counter].height/2 - 10);
  }
  
  sf.endVAdraw();
  rectMode(CORNER);
  imageMode(CORNER);

}

// Função que descobre a cor da imagem pra cada pixel dela

void t_mask() {
  switch(type) {
  
  case 0:
    
    image(tm[ncontrol_mask-1], 120, 350);
      
    loadPixels();
    updatePixels();
    
    if (mouseX > 120 && mouseX < 420 && mouseY > 350 && mouseY < 472)
      //t = tm[control_mask-1].pixels[int(mouseY - 300)*tm[control_mask-1].width + int(mouseX - 120)];
      t = tm[ncontrol_mask-1].pixels[int(mouseY - 350)*tm[ncontrol_mask-1].width + int(mouseX - 120)];
  
  break;
  
  case 1:
  
    image(tm[pcontrol_mask-1], 120, 350);
      
    loadPixels();
    updatePixels();
    
    if (mouseX > 120 && mouseX < 420 && mouseY > 350 && mouseY < 472)
      //t = tm[control_mask-1].pixels[int(mouseY - 300)*tm[control_mask-1].width + int(mouseX - 120)];
      t = tm[pcontrol_mask-1].pixels[int(mouseY - 350)*tm[pcontrol_mask-1].width + int(mouseX - 120)];
   
  break;
  }
}

void keyPressed() {
  if (key == CODED) {
    
    // >>>>>>> NMOS <<<<<<
    
    if (type == 0) {
      if (keyCode == RIGHT && angle1 < 1.589) {
        angle1 += 0.05;
        ncontrol_mask++;
        if (ncontrol_mask > 9)
          ncontrol_mask = 9;     
        
        
        // Realoca as lacunas e eletrons que estão fora de lugar
        
        for (int i = 0; i < holes.size(); i++) {
          CC carrier1 = (CC) holes.get(i);
          if (int(tm[ncontrol_mask-1].pixels[int(carrier1.py)*tm[ncontrol_mask-1].width + int(carrier1.px)]) != carrier1.color_type)
            holes.set(i, new CC(random(20, 280), random(70, 100), random(-2, 2), random(-2, 2), 1, -65536, 1));
        }
        
        for (int i = 0; i < eletrons.size(); i++) {
          CC carrier0 = (CC) eletrons.get(i);
          if (int(tm[ncontrol_mask-1].pixels[int(carrier0.py)*tm[ncontrol_mask-1].width + int(carrier0.px)]) != carrier0.color_type)
            if (i % 2 == 0)
              eletrons.set(i, new CC(random(50, 70), random(40, 50), random(-0.5, 2), random(-1, 2), -1, -256, 0));
            else
              eletrons.set(i, new CC(random(230, 250), random(40, 50), random(-0.5, 2), random(-1, 2), -1, -256, 0));
        }
        
      }
      if (keyCode == LEFT && angle1 > 0.01) {
        angle1 -= 0.05;
        if (angle1 < 0.4)
          ncontrol_mask--;
        if (ncontrol_mask < 1)
          ncontrol_mask = 1;
        
        // Realoca as lacunas e eletrons que estão fora de lugar
        
        for (int i = 0; i < holes.size(); i++) {
          CC carrier1 = (CC) holes.get(i);
          if (int(tm[ncontrol_mask-1].pixels[int(carrier1.py)*tm[ncontrol_mask-1].width + int(carrier1.px)]) != carrier1.color_type)
            holes.set(i, new CC(random(20, 280), random(70, 100), random(-2, 2), random(-2, 2), 1, -65536, 1));
        }
        
        for (int i = 0; i < eletrons.size(); i++) {
          CC carrier0 = (CC) eletrons.get(i);
          if (int(tm[ncontrol_mask-1].pixels[int(carrier0.py)*tm[ncontrol_mask-1].width + int(carrier0.px)]) != carrier0.color_type)
            if (i % 2 == 0)
              eletrons.set(i, new CC(random(50, 70), random(40, 50), random(-0.5, 2), random(-1, 2), -1, -256, 0));
            else
              eletrons.set(i, new CC(random(230, 250), random(40, 50), random(-0.5, 2), random(-1, 2), -1, -256, 0));
        }    
      }
      
      if (keyCode == UP && angle2 < 1.589)
        angle2 += 0.05;
      if (keyCode == DOWN && angle2 > 0.01)
        angle2 -= 0.05;
        
      pinched1 = angle2;
      if (pinched1 > 0.8)
        pinched1 = 0.8;
    }
    
    // >>>>>>> PMOS <<<<<<
    
   if (type == 1) {
      if (keyCode == RIGHT && angle3 < 1.589) {
        angle3 += 0.05;
        pcontrol_mask++;
        if (pcontrol_mask > 9)
          pcontrol_mask = 9;     
        
        // Realoca as lacunas e eletrons que estão fora de lugar
        
        for (int i = 0; i < eletrons2.size(); i++) {
          CC carrier0 = (CC) eletrons2.get(i);
          if (int(tm[pcontrol_mask-1].pixels[int(carrier0.py)*tm[pcontrol_mask-1].width + int(carrier0.px)]) != carrier0.color_type)
            eletrons2.set(i, new CC(random(20, 280), random(70, 100), random(-2, 2), random(-2, 2), -1, -65536, 1));
        }
        
        for (int i = 0; i < holes2.size(); i++) {
          CC carrier1 = (CC) holes2.get(i);
          if (int(tm[pcontrol_mask-1].pixels[int(carrier1.py)*tm[pcontrol_mask-1].width + int(carrier1.px)]) != carrier1.color_type)
            if (i % 2 == 0)
              holes2.set(i, new CC(random(50, 70), random(40, 50), random(-0.5, 2), random(-1, 2), +1, -256, 0));
            else
              holes2.set(i, new CC(random(230, 250), random(40, 50), random(-0.5, 2), random(-1, 2), +1, -256, 0));
        }
        
      }
      if (keyCode == LEFT && angle3 > 0.01) {
        angle3 -= 0.05;
        if (angle3 < 0.4)
          pcontrol_mask--;
        if (pcontrol_mask < 1)
          pcontrol_mask = 1;
        
        // Realoca as lacunas e eletrons que estão fora de lugar
        
        for (int i = 0; i < eletrons2.size(); i++) {
          CC carrier0 = (CC) eletrons2.get(i);
          if (int(tm[pcontrol_mask-1].pixels[int(carrier0.py)*tm[pcontrol_mask-1].width + int(carrier0.px)]) != carrier0.color_type)
            eletrons2.set(i, new CC(random(20, 280), random(70, 100), random(-2, 2), random(-2, 2), -1, -65536, 1));
        }
        
        for (int i = 0; i < holes2.size(); i++) {
          CC carrier1 = (CC) holes2.get(i);
          if (int(tm[pcontrol_mask-1].pixels[int(carrier1.py)*tm[pcontrol_mask-1].width + int(carrier1.px)]) != carrier1.color_type)
            if (i % 2 == 0)
              holes2.set(i, new CC(random(50, 70), random(40, 50), random(-0.5, 2), random(-1, 2), 1, -256, 0));
            else
              holes2.set(i, new CC(random(230, 250), random(40, 50), random(-0.5, 2), random(-1, 2), 1, -256, 0));
        }    
      }
      
      if (keyCode == UP && angle4 < 1.589)
        angle4 += 0.05;
      if (keyCode == DOWN && angle4 > 0.01)
        angle4 -= 0.05;
    }
  }
  if (key == TAB) {
      type++;
      if (type == 3)
        type = 0;
  }
  if (key == 's')
    nexp_counter++;
  if (key == 'r')
    nexp_counter--;
}

void mousePressed() {
  
  // Controla os containers
  
  if (type == 0) {
    if (mouseX > 168 && mouseX < 258 && mouseY > 57 && mouseY < 77)
      type = 1;
    if (mouseX >= 260 && mouseX <= 350 && mouseY >= 57 && mouseY <= 77)
      type = 2;
    
     // Mouse
    
    if (mouseX > 607 && mouseX < 699 && mouseY > 335 && mouseY < 358 && ncontainer_mouse == 0)
      ncontainer_mouse = 1;
    if (mouseX > 515 && mouseX < 607 && mouseY > 335 && mouseY < 358 && ncontainer_mouse == 1)
      ncontainer_mouse = 0;
    
    // Botões da explicação
    
    if (mouseX > 515 && mouseY > 305 && mouseY < 319) {
      if (mouseX < 515 + 14)
        nexp_counter = 0;
        
      for (int i = 1; i < n_exp.length; i++)
        if (mouseX > 515 + i*14 + i*3 && mouseX < 515 + (i + 1)*14 + i*3)
          nexp_counter = i;
    }
  }
  
  if (type == 1) {
    if (mouseX > 75 && mouseX < 165 && mouseY > 57 && mouseY < 77)
      type = 0;
    if (mouseX >= 260 && mouseX <= 350 && mouseY >= 57 && mouseY <= 77)
      type = 2;
    
    // Mouse
    
    if (mouseX > 607 && mouseX < 699 && mouseY > 335 && mouseY < 358 && pcontainer_mouse == 0)
      pcontainer_mouse = 1;
    if (mouseX > 515 && mouseX < 607 && mouseY > 335 && mouseY < 358 && pcontainer_mouse == 1)
      pcontainer_mouse = 0;
    
    // Botões da explicação
    
    if (mouseX > 515 && mouseY > 305 && mouseY < 319) {
      if (mouseX < 515 + 14)
        pexp_counter = 0;
        
      for (int i = 1; i < p_exp.length; i++)
        if (mouseX > 515 + i*14 + i*3 && mouseX < 515 + (i + 1)*14 + i*3)
          pexp_counter = i;
    }
  }
  
  if (type == 2) {
    if (mouseX >= 75 && mouseX <= 165 && mouseY >= 57 && mouseY <= 77)
      type = 0;
    if (mouseX >= 168 && mouseX <= 258 && mouseY >= 57 && mouseY <= 77)
      type = 1;
  }
}

void mouseDragged() {
  
  // Explicação do mouse 
      
      if (mouseX > 515 + 220 && mouseX < 515 + 225 && mouseY > yscroll + 5 + 55 && mouseY < yscroll + 5 + 20 + 55) {
        iscroll = -(mouseY - 55);
        yscroll = mouseY - 55.0;
      }
}

void mouseReleased() {
  
}
